#!/usr/bin/python

import sys, re, getopt, os

optlist,texi_files = getopt.getopt(sys.argv[1:],'io:')
process_includes = ('-i', '') in optlist # -i option: process @include's in texinfo files?
output_file = 'doc.pot'
node_list_filename = 'node_list'
for x in optlist:
	if x[0] == '-o': # -o option: PO output file name
		output_file = x[1]

node_list = open (node_list_filename, 'w')

def process_texi (filename):
	try:
		print "Processing %s..." % filename
		f = open (filename, 'r')
		matches = re.findall ("^@(node|include) (.*)$",f.read(),re.M)
		f.close()
		for item in matches:
			val = item[1]
			while val[-1] == ' ': # is there a better way to eat spaces at the end of a string?
				val = val[:-1]
			if process_includes and (item[0] == 'include'):
				process_texi (val)
			else:
				node_list.write ('_("' + val + '")\n')
	except IOError, (errno, strerror):
		print "I/O error(%s): %s" % (errno, strerror)

for texi_file in texi_files:
	process_texi (texi_file)
for word in ('Up:', 'Next:', 'Previous:', 'Appendix'):
	node_list.write('_("' + word + '")\n')
node_list.close()

os.system('xgettext -L Python -o ' + output_file + ' ' + node_list_filename)
